<template>
    <single-pane :capt="capt">
        <button @click="addSettings">Добавить</button>
        <domain-settings-grid
                :settings="participantGridSettings"
                :show-delete="true"
                :is-expeditor="settingsForExpeditor"
                @change-setting="changeSetting"
                @save="onSave"
                @revert="onRevert"
                @delete="onDelete"
        ></domain-settings-grid>
        <ob-modal
                ref="IndividualSettingsAddPopup"
                title='Выбор Клиента/Поставщика в моем домене'
                custom-class="modal-large"
                :is-show-controls="true"
                :is-read-only="true"
                :is-nested="true"
        >
            <individual-settings-add-popup
                :data-source="participantList"
                @open-set-popup="openSetSettingsPopup"
            ></individual-settings-add-popup>
        </ob-modal>
        <ob-modal
                ref="IndividualSettingsSetPopup"
                custom-class="modal-large"
                :is-nested="true"
        >
            <slot name="title">
                <div class="modal-header">
                    <i class="icon chevron-left -cobalt" @click="onBack"></i>
                    <div class="ob-ty-modal-title">Выбор индивидуальных настроек для {{activeParticipant.title}}</div>
                </div>
            </slot>
            <individual-settings-set-popup
                    :data-source="matrixParticipantSettings[activeParticipant.uuid]"
                    :active-participant="activeParticipant"
                    :is-expeditor="settingsForExpeditor"
                    @close="onCloseSetPopup"
                    @save="onSave"
                    @revert="onRevert"
                    @change-setting="changeSetting"
            ></individual-settings-set-popup>
        </ob-modal>
        <ob-modal
                ref="IndividualSettingsDeletePopup"
                :title="'Удалить индивидуальные настройки для ' + activeParticipant.title + '?'"
                custom-class="modal-medium"
                :is-show-controls="true"
                ok-text="Удалить"
                @save="onSuccessDelete"
        >
        </ob-modal>
    </single-pane>
</template>

<script>
    import api from "../../api"
    import cloneDeep from 'clone-deep'
    import SinglePane from "common-components/src/obComponents/obSinglePanels";
    import DomainSettingsGrid from "./domain-settings/DomainSettingsGrid";
    import { PARTICIPANT_ROLES, VIEW_DIRECTION, VISIBILITY_PERMISSION, LINK_PERMISSION } from '../../resources/log_domains_const'
    import { getCookie } from '../../utils/cookie'
    import jwt_decode from 'jwt-decode';
    const token = getCookie('auth_token')
    const userData = token ? jwt_decode(token) : {}
    import {
        GET_CHANGED_PARTICIPANT_SETTINGS,
        GET_CHANGED_LINKS_PARTICIPANT_SETTINGS,
        PREPARED_CHANGE_SCOPE
    } from '../../helpers/logistic-domains/participant-settings'
    import {
        GET_CHANGED_EXPEDITOR_LINKS_PARTICIPANT_SETTINGS,
        PREPARED_EXPEDITOR_CHANGE_SCOPE
    } from '../../helpers/logistic-domains/moderator/participant-expeditor-settings'
    import ObModal from "common-components/src/obComponents/obModal";
    import IndividualSettingsAddPopup from "./modal/IndividualSettingsAddPopup";
    import IndividualSettingsSetPopup from "./modal/IndividualSettingsSetPopup";
    import {
        GET_CHANGED_DOMAIN_SETTINGS,
    } from '../../helpers/logistic-domains/expeditor/domain-settings'

    export default {
        name: "IndividualClientCarrierDomainSettings",
        components: {IndividualSettingsSetPopup, IndividualSettingsAddPopup, ObModal, DomainSettingsGrid, SinglePane},
        props: {
            settingsForExpeditor: {
                type: Boolean,
                default: false
            }
        },
        computed: {
            api () {
                return api.domainSettingsModerator
            },
            capt () {
                let _capt = !this.settingsForExpeditor ? 'Клиентов и Поставщиков' : 'Экспедиторов'
                return 'Индивидуальные настройки  ' + _capt
            },
            linkAccessList () {
                return [
                    { access: LINK_PERMISSION.ALLOWED, name: 'Может создать линк', description: 'Некоторое описание параметров видимости' },
                    { access: LINK_PERMISSION.BY_REQUEST, name: 'Требует согласования', description: 'Некоторое описание параметров видимости' },
                    { access: LINK_PERMISSION.DISALLOWED, name: 'Не может создать линк', description: 'Некоторое описание параметров видимости' }
                ]
            },
            accessList () {
                return [
                    { access: VISIBILITY_PERMISSION.VISIBILITY, name: 'Видит', description: 'Некоторое описание параметров видимости' },
                    { access: VISIBILITY_PERMISSION.NOT_VISIBILITY, name: 'Не видит', description: 'Некоторое описание параметров видимости' }
                ]
            },
            participantExpeditorSettings () {
                return {
                    orgInDomainSettings: [
                        {
                            id: 1,
                            name: 'Экспедитор',
                            description: 'видит',
                            role: PARTICIPANT_ROLES.EXPEDITOR,
                            isExpeditor: true,
                            viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
                            accessList: [
                                { keyAccess: 0, disabled: true, availableAccessList: this.accessList, type: 'Меня', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 1, disabled: true, availableAccessList: this.accessList, type: 'Своих Клиентов и Поставщиков', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 2, disabled: false, availableAccessList: this.accessList, moderator: true, type: 'Других Экспедиторов', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 3, disabled: false, availableAccessList: this.accessList, type: 'Чужих Клиентов и Поставщиков', access: VISIBILITY_PERMISSION.VISIBILITY }
                            ]
                        },
                        {
                            id: 2,
                            name: 'Клиенты Экспедитора',
                            description: 'видят',
                            isExpeditor: true,
                            role: PARTICIPANT_ROLES.CLIENT,
                            viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
                            accessList: [
                                { keyAccess: 0, disabled: true, availableAccessList: this.accessList, type: 'Своего Экспедитора', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 1, disabled: true, availableAccessList: this.accessList, type: 'Поставщиков своего Экспедитора', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 2, disabled: false, availableAccessList: this.accessList, type: 'Меня и других Экспедиторов', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 3, disabled: false, availableAccessList: this.accessList, type: 'Чужих Поставщиков', access: VISIBILITY_PERMISSION.VISIBILITY }
                            ]
                        },
                        {
                            id: 3,
                            name: 'Поставщики Экспедитора',
                            description: 'видят',
                            isExpeditor: true,
                            role: PARTICIPANT_ROLES.CARRIER,
                            viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
                            accessList: [
                                { keyAccess: 0, disabled: true, availableAccessList: this.accessList, type: 'Своего Экспедитора', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 1, disabled: true, availableAccessList: this.accessList, type: 'Клиентов своего Экспедитора',  access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 2, disabled: false, availableAccessList: this.accessList, type: 'Меня и других Экспедиторов', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 3, disabled: false, availableAccessList: this.accessList, type: 'Чужих Клиентов', access: VISIBILITY_PERMISSION.VISIBILITY }
                            ]
                        }
                    ],
                    orgInDomainFromOtherOrgSettings: [
                        {
                            id: 1,
                            name: 'Экспедитора',
                            description: 'видят',
                            isExpeditor: true,
                            role: PARTICIPANT_ROLES.EXPEDITOR,
                            viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
                            accessList: [
                                { keyAccess: 0, disabled: true, availableAccessList: this.accessList, type: 'Я', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 1, disabled: true, availableAccessList: this.accessList, type: 'Свои Клиенты и Поставщики', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 2, disabled: false, availableAccessList: this.accessList, moderator: true, type: 'Другие Экспедиторы', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 3, disabled: false, availableAccessList: this.accessList, type: 'Чужие Клиенты и Поставщики', access: VISIBILITY_PERMISSION.VISIBILITY }
                            ]
                        },
                        {
                            id: 2,
                            name: 'Клиентов Экспедитора',
                            description: 'видят',
                            isExpeditor: true,
                            role: PARTICIPANT_ROLES.CLIENT,
                            viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
                            accessList: [
                                { keyAccess: 0, disabled: true, availableAccessList: this.accessList, type: 'Свой Экспедитор', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 1, disabled: true, availableAccessList: this.accessList, type: 'Поставщики своего Экспедитора', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 2, disabled: false, availableAccessList: this.accessList, type: 'Я и другие Экспедиторы', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 3, disabled: false, availableAccessList: this.accessList, type: 'Чужие Поставщики', access: VISIBILITY_PERMISSION.VISIBILITY }
                            ]
                        },
                        {
                            id: 3,
                            name: 'Поставщиков Экспедитора',
                            description: 'видят',
                            isExpeditor: true,
                            role: PARTICIPANT_ROLES.CARRIER,
                            viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
                            accessList: [
                                { keyAccess: 0, disabled: true, availableAccessList: this.accessList, type: 'Свой Экспедитор', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 1, disabled: true, availableAccessList: this.accessList, type: 'Клиенты своего Экспедитора', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 2, disabled: false, availableAccessList: this.accessList, type: 'Я и другие Экспедиторы', access: VISIBILITY_PERMISSION.VISIBILITY },
                                { keyAccess: 3, disabled: false, availableAccessList: this.accessList, type: 'Чужие Клиенты', access: VISIBILITY_PERMISSION.VISIBILITY }
                            ]
                        }
                    ],
                    accessCreateLinkForOrgInDomainSettings: [
                        {
                            id: 1,
                            name: 'Экспедитор',
                            description: 'может создавать',
                            isExpeditor: true,
                            role: PARTICIPANT_ROLES.EXPEDITOR,
                            viewDirection: VIEW_DIRECTION.LINKS,
                            accessList: [
                                { keyAccess: 0, disabled: true, availableAccessList: this.linkAccessList, type: 'Внутренние линки со своими Клиентами и Поставщиками', access: LINK_PERMISSION.ALLOWED },
                                { keyAccess: 1, disabled: false, availableAccessList: this.linkAccessList, type: 'Внешние линки с другими Экспедиторами', access: LINK_PERMISSION.ALLOWED },
                                { keyAccess: 2, disabled: false, availableAccessList: this.linkAccessList, type: 'Внешние линки с чужими Клиентами и Поставщиками', access: LINK_PERMISSION.ALLOWED },
                                { keyAccess: 3, disabled: false, availableAccessList: this.linkAccessList, type: 'Публичные линки', access: LINK_PERMISSION.ALLOWED }
                            ]
                        },
                        {
                            id: 2,
                            name: 'Клиенты Экспедитора',
                            description: 'могут создавать',
                            isExpeditor: true,
                            role: PARTICIPANT_ROLES.CLIENT,
                            viewDirection: VIEW_DIRECTION.LINKS,
                            accessList: [
                                { keyAccess: 0, disabled: true, availableAccessList: this.linkAccessList, type: 'Внутренние линки с Поставщиками своего Экспедитора', access: LINK_PERMISSION.ALLOWED },
                                { keyAccess: 1, disabled: false, availableAccessList: this.linkAccessList, type: 'Внешние линки со Мной и другими Экспедиторами', access: LINK_PERMISSION.ALLOWED },
                                { keyAccess: 2, disabled: false, availableAccessList: this.linkAccessList, type: 'Внешние линки с чужими Поставщиками', access: LINK_PERMISSION.ALLOWED },
                                { keyAccess: 3, disabled: false, availableAccessList: this.linkAccessList, type: 'Публичные линки', access: LINK_PERMISSION.ALLOWED }
                            ]
                        },
                        {
                            id: 3,
                            name: 'Поставщики Экспедитора',
                            description: 'могут создавать',
                            isExpeditor: true,
                            role: PARTICIPANT_ROLES.CARRIER,
                            viewDirection: VIEW_DIRECTION.LINKS,
                            accessList: [
                                { keyAccess: 0, disabled: true, availableAccessList: this.linkAccessList, type: 'Внутренние линки с Клиентами своего Экспедитора', access: LINK_PERMISSION.ALLOWED },
                                { keyAccess: 1, disabled: false, availableAccessList: this.linkAccessList, type: 'Внешние линки со Мной и другими Экспедиторами', access: LINK_PERMISSION.ALLOWED },
                                { keyAccess: 2, disabled: false, availableAccessList: this.linkAccessList, type: 'Внешние линки с чужими Клиентами', access: LINK_PERMISSION.ALLOWED },
                                { keyAccess: 3, disabled: false, availableAccessList: this.linkAccessList, type: 'Публичные линки', access: LINK_PERMISSION.ALLOWED }
                            ]
                        }
                    ]
                }
            }
        },
        mounted () {
            this.getParticipantsWithPersonalSettings()
        },
        data: () => ({
            initialParticipantSettings: {},
            matrixParticipantSettings: {},
            participantDomainSettings: [],
            participantGridSettings: [],
            changedParticipantSettings: {},
            activeParticipant: {},
            domainSettings: [],
            role: 'moderator',
            participantList: [],
            userData
        }),
        methods: {
            // Получение списка участников с индивидуальными настройками
            getParticipantsWithPersonalSettings() {
                try {
                    this.participantGridSettings = []
                    this.api.getParticipantsWithPersonalSettings().then(({data}) => {
                        data.participants.forEach(item => {
                            console.log(item)
                            let _isParticipant = this.settingsForExpeditor ? item.role.toUpperCase() === PARTICIPANT_ROLES.EXPEDITOR : item.role.toUpperCase() !== PARTICIPANT_ROLES.EXPEDITOR;
                            if (_isParticipant) {
                                this.getParticipantSettings(item, true)
                            }
                        })
                    })
                } catch (e) {
                    console.error(e);
                    this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
                }
            },
            // Получение индивидуальных настроек для участника
            getParticipantSettings(participant, updateFlag) {
                try {
                    // TODO this.settingsForExpeditor в этом сервисе только для mock
                    this.api.getParticipantSettings(participant.uuid, this.settingsForExpeditor).then(({data}) => {
                        this.setConvertedParticipantSettings(participant, data.settings)
                        if (updateFlag) {
                            this.setParticipantGridSetting(participant)
                        }
                    })
                } catch (e) {
                    console.error(e);
                    this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
                }
            },
            setConvertedParticipantSettings (participant, settings) {
                this.initialParticipantSettings[participant.uuid] = settings
                this.matrixParticipantSettings[participant.uuid] = this.settingsForExpeditor ? this.getConvertedExpeditorParticipantSettings(settings) :
                    this.getConvertedParticipantSettings(participant, settings)
                this.activeParticipant = participant
            },
            setParticipantGridSetting (participant) {
                let _isSetting;
                let _grid = this.participantGridSettings.map(setting => {
                    if(setting.uuid === participant.uuid) {
                        setting.value = this.matrixParticipantSettings[participant.uuid];
                        _isSetting = true;
                    }
                    return setting;
                });
                if(!_isSetting) {
                    let _role = participant.role ? participant.role.toLowerCase() : '';
                    this.participantGridSettings.push({
                        uuid: participant.uuid,
                        id: participant.uuid,
                        role: participant.role,
                        title: participant.title,
                        type: 'access-grid',
                        icon: _role + '-blue',
                        editItemCount: 0,
                        value: this.matrixParticipantSettings[participant.uuid]
                    });
                }
                else this.participantGridSettings = _grid
            },
            //Получение доменных настроек для экспедитора
            getConvertedExpeditorParticipantSettings (settings) {
                let _settings = cloneDeep(this.participantExpeditorSettings)
                settings.forEach(setting => {
                    let indexParticipantRole;
                    switch (setting.participantRole) {
                        case PARTICIPANT_ROLES.EXPEDITOR:
                            indexParticipantRole = 0;
                            break;
                        case PARTICIPANT_ROLES.CLIENT:
                            indexParticipantRole = 1;
                            break;
                        case PARTICIPANT_ROLES.CARRIER:
                            indexParticipantRole = 2;
                            break;
                    }
                    let indexTargetParticipantRole;
                    let indexLinkPermission;
                    switch (setting.targetParticipantRole) {
                        case PARTICIPANT_ROLES.MODERATOR:
                        case PARTICIPANT_ROLES.EXPEDITOR:
                            indexTargetParticipantRole = !setting.isCrossDomainScope ? 0 : 2;
                            if(setting.isCrossDomainScope) {
                                indexLinkPermission = 1;
                            }
                            break;
                        case PARTICIPANT_ROLES.CLIENT:
                        case PARTICIPANT_ROLES.CARRIER:
                            indexTargetParticipantRole = !setting.isCrossDomainScope ? 1 : 3;
                            indexLinkPermission = !setting.isCrossDomainScope ? 0 : 2;
                            break;
                    }
                    switch (setting.viewDirection) {
                        case VIEW_DIRECTION.BY_PARTICIPANT:
                            _settings.orgInDomainSettings[indexParticipantRole].accessList[indexTargetParticipantRole].access = setting.visibilityPermission;
                            if((setting.targetParticipantRole === PARTICIPANT_ROLES.EXPEDITOR && setting.isCrossDomainScope) ||
                                (setting.targetParticipantRole === PARTICIPANT_ROLES.MODERATOR && setting.isCrossDomainScope) ||
                                setting.targetParticipantRole === PARTICIPANT_ROLES.CLIENT ||
                                setting.targetParticipantRole === PARTICIPANT_ROLES.CARRIER) {
                                _settings.orgInDomainFromOtherOrgSettings[indexParticipantRole].accessList[3].access = setting.publicateLinkPermission;
                            }
                            if(indexLinkPermission !== undefined) {
                                _settings.accessCreateLinkForOrgInDomainSettings[indexParticipantRole].accessList[indexLinkPermission].access = setting.createLinkPermission;
                            }
                            break;
                        case VIEW_DIRECTION.AT_PARTICIPANT:
                            _settings.orgInDomainFromOtherOrgSettings[indexParticipantRole].accessList[indexTargetParticipantRole].access = setting.visibilityPermission;
                            break;
                    }
                });
                return [
                    { id: 1, title: 'Параметры видимости участников внутри домена Экспедитора', viewDirection: VIEW_DIRECTION.BY_PARTICIPANT, type: 'access-grid', value: _settings.orgInDomainSettings },
                    { id: 2, title: 'Параметры видимости участников внутри домена Экспедитора со стороны других участников', viewDirection: VIEW_DIRECTION.AT_PARTICIPANT, type: 'access-grid', value: _settings.orgInDomainFromOtherOrgSettings },
                    { id: 3, title: 'Возможность создания линков для участников в домене Экспедитора', viewDirection: VIEW_DIRECTION.LINKS, type: 'access-grid', value: _settings.accessCreateLinkForOrgInDomainSettings },
                ];
            },
            getConvertedParticipantSettings(participant, settings) {
                let _settings = this.getIndividualClientCarrierSettings(participant.role.toUpperCase());
                settings.forEach(setting => {
                    let indexTargetParticipantRole;
                    let indexLinkPermission;
                    switch (setting.targetParticipantRole) {
                        case PARTICIPANT_ROLES.EXPEDITOR:
                            indexTargetParticipantRole = !setting.isCrossDomainScope ? 0 : 2;
                            if(setting.isCrossDomainScope) {
                                indexLinkPermission = 1;
                            }
                            break;
                        case PARTICIPANT_ROLES.MODERATOR:
                            indexTargetParticipantRole = 0;
                            break;
                        case PARTICIPANT_ROLES.CLIENT:
                        case PARTICIPANT_ROLES.CARRIER:
                            indexTargetParticipantRole = !setting.isCrossDomainScope ? 1 : 3;
                            indexLinkPermission = !setting.isCrossDomainScope ? 0 : 2;
                            break;
                    }
                    if(indexTargetParticipantRole !== undefined) {
                        switch (setting.viewDirection) {
                            case VIEW_DIRECTION.BY_PARTICIPANT:
                                _settings[0].accessList[indexTargetParticipantRole].access = setting.visibilityPermission;
                                _settings[2].accessList[3].access = setting.publicateLinkPermission;
                                if(indexLinkPermission !== undefined) {
                                    _settings[2].accessList[indexLinkPermission].access = setting.createLinkPermission;
                                    if(setting.isCreateLinkPermissionDisabled) {
                                        _settings[2].accessList[indexLinkPermission].moderator = true;
                                        _settings[2].accessList[indexLinkPermission].disabled = true;
                                    }
                                    if(setting.isPublicateLinkPermissionDisabled) {
                                        _settings[2].accessList[3].moderator = true;
                                        _settings[2].accessList[3].disabled = true;
                                    }
                                }
                                break;
                            case VIEW_DIRECTION.AT_PARTICIPANT:
                                _settings[1].accessList[indexTargetParticipantRole].access = setting.visibilityPermission;
                                break;
                        }
                    }
                });
                return _settings;
            },
            getIndividualClientCarrierSettings (role) {
                let isClient = role === PARTICIPANT_ROLES.CLIENT;
                return cloneDeep([
                    {
                        id: 1,
                        name: isClient ? 'Клиент' : 'Поставщик',
                        description: 'видит',
                        viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, availableAccessList: this.accessList, type: 'Меня', access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: false, availableAccessList: this.accessList, type: isClient ? 'Моих Поставщиков' : 'Моих Клиентов', access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, availableAccessList: this.accessList, type: 'Других Экспедиторов', access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, availableAccessList: this.accessList, type: isClient ? 'Чужих Поставщиков' : 'Чужих Клиентов', access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    },
                    {
                        id: 2,
                        name: isClient ? 'Клиента' : 'Поставщика',
                        description: 'видят',
                        viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
                        accessList: [
                            { keyAccess: 0, disabled: true, availableAccessList: this.accessList, type: 'Я', access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 1, disabled: false, availableAccessList: this.accessList, type: isClient ? 'Мои Поставщики' : 'Мои Клиенты', access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 2, disabled: false, availableAccessList: this.accessList, type: 'Другие Экспедиторы', access: VISIBILITY_PERMISSION.VISIBILITY },
                            { keyAccess: 3, disabled: false, availableAccessList: this.accessList, type: isClient ? 'Чужие Поставщики' : 'Чужие Клиенты', access: VISIBILITY_PERMISSION.VISIBILITY }
                        ]
                    },
                    {
                        id: 3,
                        name: isClient ? 'Клиент' : 'Поставщик',
                        description: 'может создавать',
                        viewDirection: VIEW_DIRECTION.LINKS,
                        accessList: [
                            { keyAccess: 0, disabled: false, availableAccessList: this.linkAccessList, type: isClient ? 'Внутренние линки с Поставщиками моего домена' : 'Внутренние линки с Клиентами моего домена', access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 1, disabled: false, availableAccessList: this.linkAccessList, type: 'Внешние линки со Мной и другими Экспедиторами', access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 2, disabled: false, availableAccessList: this.linkAccessList, type: isClient ? 'Внешние линки с чужими Поставщиками' : 'Внешние линки с чужими Клиентами', access: LINK_PERMISSION.ALLOWED },
                            { keyAccess: 3, disabled: false, availableAccessList: this.linkAccessList, type: 'Публичные линки', access: LINK_PERMISSION.ALLOWED }
                        ]
                    }
                ]);
            },
            addSettings () {
                try {
                    this.api.getParticipantsWithoutPersonalSettings().then(({data}) => {
                        this.participantList = data.participants.filter(participant => {
                            return this.settingsForExpeditor ? participant.role.toUpperCase() === PARTICIPANT_ROLES.EXPEDITOR : participant.role.toUpperCase() !== PARTICIPANT_ROLES.EXPEDITOR;
                        })
                        this.$refs.IndividualSettingsAddPopup.open();
                    })
                } catch (e) {
                    console.error(e);
                    this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
                }
            },
            openSetSettingsPopup (participant) {
                this.getParticipantSettings(participant, false)
                this.$refs.IndividualSettingsSetPopup.open(this.activeParticipant)
                this.$refs.IndividualSettingsAddPopup.close()
            },
            resetChangedParticipantSetting (participant) {
                this.changedParticipantSettings[participant.uuid] = []
                this.activeParticipant = {}
            },
            onBack () {
                this.$refs.IndividualSettingsSetPopup.close();
                this.$refs.IndividualSettingsAddPopup.open();
            },
            changeSetting (row, access, status, participant) {
                if(row.id || row.uuid) {
                    let functionChange
                    if(!this.changedParticipantSettings[participant.uuid]) {
                        this.changedParticipantSettings[participant.uuid] = []
                    }
                    if(row.viewDirection !== VIEW_DIRECTION.LINKS) {
                        functionChange = this.settingsForExpeditor ? GET_CHANGED_DOMAIN_SETTINGS : GET_CHANGED_PARTICIPANT_SETTINGS
                    }
                    else {
                        functionChange = this.settingsForExpeditor ? GET_CHANGED_EXPEDITOR_LINKS_PARTICIPANT_SETTINGS : GET_CHANGED_LINKS_PARTICIPANT_SETTINGS
                    }
                    this.changedParticipantSettings[participant.uuid] = functionChange(
                        this.changedParticipantSettings[participant.uuid],
                        this.initialParticipantSettings[participant.uuid],
                        row, access, participant
                    )
                }
            },
            onSave(participant) {
                let notificationId = new Date().getTime() + 'save';
                this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});
                let preparedSettings = this.settingsForExpeditor ? PREPARED_EXPEDITOR_CHANGE_SCOPE(
                    this.changedParticipantSettings[participant.uuid],
                    participant.uuid
                    )
                    : PREPARED_CHANGE_SCOPE(
                        this.changedParticipantSettings[participant.uuid],
                        participant.uuid,
                        this.userData.contractor_uuid
                    );
                this.api[this.settingsForExpeditor ? 'saveExpeditorParticipantSettings' : 'saveParticipantSettings'](participant.uuid, {
                    settings: preparedSettings
                }).then(({data}) => {
                    this.setConvertedParticipantSettings(participant, data.settings)
                    this.setParticipantGridSetting(participant)
                    this.resetChangedParticipantSetting(participant)
                    this.$refs.IndividualSettingsSetPopup.close()
                }).catch((e) => {
                    console.error(e);
                    this.$notification({
                        type: 'system_notification_error',
                        message: 'Не сохранено'
                    })
                }).finally(() => {
                    this.$notification({event: 'close', id: notificationId})
                });

            },
            onRevert (group) {
                this.changedParticipantSettings[group.uuid] = []
            },
            onDelete (group) {
                this.activeParticipant = group
                this.$refs.IndividualSettingsDeletePopup.open()
                console.log(group)
            },
            onCloseSetPopup () {
                this.changedParticipantSettings[this.activeParticipant.uuid] = []
                this.activeParticipant = {}
                this.$refs.IndividualSettingsSetPopup.close()
            },
            onSuccessDelete() {
                let notificationId = new Date().getTime() + 'remove';

                this.$notification({type: 'system_notification_in_load', message: 'Удаление', id: notificationId});
                this.api.deleteParticipantSettings(this.activeParticipant.uuid).then(() => {
                    this.$refs.IndividualSettingsDeletePopup.close()
                    this.activeParticipant = {}
                    this.getParticipantsWithPersonalSettings()
                    this.$notification({
                        type: 'system_notification_success',
                        message: 'Удалено'
                    })
                }).catch((e) => {
                    console.error(e);
                    this.$notification({
                        type: 'system_notification_error',
                        message: 'Не сохранено'
                    })
                }).finally(() => {
                    this.$notification({event: 'close', id: notificationId})
                });
            }
        }
    }
</script>

<style lang="scss" scoped>
    .modal-header {
        display: flex;
        .icon {
            margin-right: 10px;
            margin-top: 7px;
            align-self: flex-start;
            font-size: 22px;
            cursor: pointer;
        }
        .ob-ty-modal-title {
            flex-grow: 1;
        }
    }
</style>
